> For the complete documentation index, see [llms.txt](https://docs.xplorpay.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xplorpay.com/guides/mobile-emv/clearentwrapper/pair-card-reader.md).

# Pair card reader

To process card-present transactions, pair a VP3300 reader via Bluetooth.

### Start pairing

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
ClearentWrapper.shared.startPairing(reconnectIfPossible: true)
```

{% endcode %}

### Handle discovered readers

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
ClearentWrapper.shared.connectTo(reader: reader)
```

{% endcode %}

### Pairing completion

{% code title="" overflow="wrap" lineNumbers="true" %}

```swift
func didFinishedPairing() {
    // Reader is connected and ready
}
```

{% endcode %}

### Pairing a VP3300 card reader works

1. The SDK scans for nearby readers.
2. Returns a list of available devices.
3. You present the list to the user.
4. The user selects a reader.
5. The SDK connects and confirms pairing.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.xplorpay.com/guides/mobile-emv/clearentwrapper/pair-card-reader.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
